/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _MathStructures_included_
#define _MathStructures_included_

# include "TypeDef.h"

struct xyStruct
{
        vector<Real> x, y;
};

struct Complex
{
	Real real, imag;
};

struct LookUpStruct
{
	Vector cosLookUp, cosDer, sinLookUp, sinDer, expLookUp;
	Vector cosLookUpA, cosLookUpB, cosLookUpC;
	Vector sinLookUpA, sinLookUpB, sinLookUpC;
	Vector negativeExpLookUp, negativeExpDer;
	Real cosBin, sinBin, expBin, expMax, negativeExpBin, negativeExpMax;
	Real invCosBin, invSinBin, invExpBin, invNegativeExpBin;

	LookUpStruct& operator = (const LookUpStruct &lookUp);
};
/*
LookUpStruct::~LookUpStruct
{
	cosLookUp.clear();
	sinLookUp.clear();
	exoLookUp.clear();
}
*/
#endif
