/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _readPdb_include_
#define _readPdb_include_
# include "AssignAtomIDs.h"
# include "AtomCode.h"
# include "GetAtomType.h"
# include "GetAtomType2.h"
# include "ReadPdb.h"
# include "ResidueCode.h"
# include "ResidueID.h"
# include "Structures.h"
# include "StringUtils.h"
# include "TypeDef.h"
# include "LinkedList.h"
# include "IOUtils.h"
# include "VectorManip.h"
int CountAtomsInPdb(string PdbFile);
void readPdb(string PdbFile, ProteinStruct &Protein);
void readPdbs(string pdbListFile, vector<ProteinStruct> &Proteins);
bool readAnisou(string line, vector<Real> &anisou);
bool pdbLineToInfo(string line, bool &HetAtom, int &AtomNumber, string &AtomName, string &duplicate, string &ResidueName, string &ChainName, int &ResidueNum, Real &x, Real &y, Real &z, Real &Occupancy, Real &BFactor, string &SegID, string &ID);
void PdbLineToAtom(string line, AtomStruct &Atom);
void PdbLinesToAtoms(vector<string> &lines, vector<AtomStruct> &Atoms);
int readPdb(string PdbFile, vector<AtomStruct> &Atoms);
void MinMaxPdb(string PdbFile, Real &xmin, Real &ymin, Real &zmin, Real &xmax, Real &ymax, Real &zmax);
void ReadXYZ(string xyz, vector<AtomStruct> &Atoms);
void ReadXYZLine(string line, AtomStruct Atom);
#endif
