/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _ReadRTF_included_
#define _ReadRTF_included_

# include "IOUtils.h"
# include "LinkedList.h"
# include "ReadPdb.h"
# include "ResidueCode.h"
# include "StringUtils.h"
# include "Structures.h"
# include "PrintPdb.h"
# include "VectorManip.h"

struct PatchStruct
{
        string first, last, ResidueName;
};

void applyPatch(string patch, string ResidueName, vector<AtomStruct> &CharmmAtoms);
void applyPatches(vector<PatchStruct> &Patch, vector<AtomStruct> &CharmmAtoms);
void ReadRtfFile(string RtfFile, vector<AtomStruct> &CharmmAtoms);
#endif
