/*
    JV Library
    Copyright (C) 2014  Jouko Juhani Virtanen

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _rmsd_include_
#define _rmsd_include_
Real RMSDNoAlign(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2);
Real RMSDNoAlign(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2, vector<bool> &use);
Real RMSDNoAlignAll(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2);
Real EvaluateOrientation(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2, Real theta, Real phi, Real psi, vector<bool> &use);
void Rotate(vector<AtomStruct> &Atoms, Real step, int RotationType);
Real CalcDerivative(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2, Real step, int RotationType, Real theta, Real phi, Real psi, vector<bool> &use);
Real CalcGradient(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2, Real derivative[3], Real theta, Real phi, Real psi, vector<bool> &use);
Real GridSearch(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2, Real &theta, Real &phi, Real &psi, vector<bool> &use);
void GetStep(Real derivative[], Real step[], Real TotalStep);
Real MinimizeAlongVector(vector<AtomStruct> Atoms1, vector<AtomStruct> Atoms2, Real derivative[], Real &theta, Real &phi, Real &psi, vector<bool> &use);
Real RMSD(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2, Real &theta, Real &phi, Real &psi, vector<bool> &use);
void setDefaultUse(vector<AtomStruct> &Atoms, vector<bool> &use);
Real RMSD(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2);
Real RMSD_CA(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2);
Real RMSD_CA(string pdbFile, ProteinStruct Protein2);
bool removeOutliers(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2, Real cutOff);
Real RMSD_NoOutliers(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2);
Real RMSD_NoOutliers(vector<AtomStruct> &Atoms1, vector<AtomStruct> &Atoms2, Real cutOff);
#endif
